// ----------------------------------------------------------------------------
// ILSS_PAR 
// ----------------------------------------------------------------------------
// Parallel Interval Linear System Solver
// Approximate matrix inversion module
// ----------------------------------------------------------------------------
// Paralleler Verifizierter Loeser fuer lineare Intervallgleichungssysteme
// Modul zur naeherungsweisen Invertierung einer Matrix
// ----------------------------------------------------------------------------
// Copyright (C) 2004-2007 Markus Grimmer
//
// markus.grimmer@math.uni-wuppertal.de
// ----------------------------------------------------------------------------

// This file is part of the Parallel Interval Linear System Solver ILSS_PAR.
// 
// ILSS_PAR is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// ILSS_PAR is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with ILSS_PAR; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

/**
 * @file matinv_aprx_par.hpp
 * 
 * ILSS_PAR Parallel Interval Linear System Solver 
 * Approximate matrix inversion module header.
 * 
 * Copyright (C) 2004-2007 Markus Grimmer
 *
 * Parallel approximate matrix inversion using LU decomposition
 * and forward-backward substitution,
 * column distribution, pivoting and send ahead
 */

#ifndef __MATINV_APRX_PAR_HPP
#define __MATINV_APRX_PAR_HPP

#include <rmatrix.hpp>   
#include <intvector.hpp>  

#include <vector>  

using namespace cxsc;
using namespace std;


extern void MatInv ( rmatrix&, rmatrix&, 
                     rmatrix&, vector<int>&, intvector&, 
                     bool, int, int, int&, int&, ofstream& );
extern void MatInv ( rmatrix&, rmatrix&, int, int, int&, int&, ofstream& );
extern void MatInv ( rmatrix&, rmatrix&, int&, int&, ofstream& );

#endif
