// ----------------------------------------------------------------------------
// ILSS_PAR 
// ----------------------------------------------------------------------------
// Parallel Interval Linear System Solver
// Matrix multiplication/operation module
// ----------------------------------------------------------------------------
// Paralleler Verifizierter Loeser fuer lineare Intervallgleichungssysteme
// Modul fuer Matrixoperationen
// ----------------------------------------------------------------------------
// Copyright (C) 2004-2007 Markus Grimmer
//
// markus.grimmer@math.uni-wuppertal.de
// ----------------------------------------------------------------------------

// This file is part of the Parallel Interval Linear System Solver ILSS_PAR.
// 
// ILSS_PAR is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// ILSS_PAR is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with ILSS_PAR; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

/**
 * @file matmul_par.hpp
 * 
 * ILSS_PAR Parallel Interval Linear System Solver 
 * Matrix multiplication/operation module header.
 * 
 * Copyright (C) 2004-2007 Markus Grimmer
 *
 * Contains a number of parallel matrix operations 
 * (including matrix multiplication) for 
 * the parallel verified linear system solver ILSS_PAR.
 * 
 */


#ifndef __MATMUL_PAR_HPP
#define __MATMUL_PAR_HPP

#include <fstream> 
#include <vector>      
#include <rmatrix.hpp> 
#include <imatrix.hpp> 

using namespace cxsc;
using namespace std;

extern void MatMul ( imatrix&, imatrix&, imatrix&, int, int, int, int, int, int, 
              int&, int&, ofstream& );

extern void MatMul ( rmatrix&, rmatrix&, rmatrix&, int, int, int, int, int, int, 
              int&, int&, ofstream& );

extern void IminusAB ( rmatrix&, imatrix&, imatrix&, int, int, int, int, int, int, 
              int&, int&, ofstream& );

extern void IminusA1A2B ( rmatrix&, rmatrix&, imatrix&, imatrix&, 
              int, int, int, int, int, int, int&, int&, ofstream& );

extern void ABminusRndAB ( rmatrix&, rmatrix&, rmatrix&, rmatrix&, 
            int, int, int, int, int, int, int&, int&, ofstream&);

#endif
