// ----------------------------------------------------------------------------
// This package is part of:
// ----------------------------------------------------------------------------
// VFIS 
// ----------------------------------------------------------------------------
// Verified Fredholm Integral Equation Solver
// for linear Fredholm Integral Equations of the second kind
// (Parallel System Version)
// ----------------------------------------------------------------------------
// Verifizierter Integralgleichungsloeser 
// fuer lineare Fredholmsche Integralgleichungen zweiter Art
// (Parallele Systemversion)
// ----------------------------------------------------------------------------
// Copyright (c) 2004-2007 Markus Grimmer
//
// markus.grimmer@math.uni-wuppertal.de
// ----------------------------------------------------------------------------

// This file is part of the Verified Fredholm Integral Equation Solver VFIS.
// 
// VFIS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// VFIS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with VFIS; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

/**
 * @file vectoroperations.hpp
 * Additional vector operators for STL vectors (Header).
 */

#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

/**
 * vector assignment
 */
template<class T>
void fixedassign(vector<T>&, vector<T>&);

/**
 * vector& + vector&
 */
template<class T> 
vector<T> operator+ (vector<T>&, vector<T>&);

/**
 * vector& + vector
 */
template<class T> 
vector<T> operator+ (vector<T>&, vector<T>);

/**
 * vector& < vector
 */
template<class T> 
bool operator< (vector<T>&, vector<T>);

/**
 * vector& <= vector
 */
template<class T> 
bool operator<= (vector<T>&, vector<T>);

/**
 * vector& > vector
 */
template<class T> 
bool operator> (vector<T>&, vector<T>);

/**
 * vector& >= vector
 */
template<class T> 
bool operator>= (vector<T>&, vector<T>);

/**
 * vector output
 */
template<class T> 
ostream& operator<< (ostream&, vector<T>&);

/**
 * vector output
 */
template<class T> 
ofstream& operator<< (ofstream&, vector<T>&);
